#include "taskFlyport.h"
#define SETUP_UFFICIO
//#define SETUP_CASA

//DEFINE GPIO
#define LED2_ON           IOPut(D4Out , 1)   //OUT5 su Net - Led D2 su flyport
#define LED2_OFF          IOPut(D4Out , 0)
#define LED2_TOGGLE       IOPut(D4Out , IOGet(D4Out) ^ 0x01)

#define LED3_ON           IOPut(D5Out , 1)   //OUT4 su Net - Led D1 su flyport
#define LED3_OFF          IOPut(D5Out , 0)
#define LED3_TOGGLE       IOPut(D5Out , IOGet(D5Out) ^ 0x01)

#define LINE_CLOCK       D5In
#define LINE_RELE_DATA   D4In
#define LINE_RELE_STROBE D3In
#define LINE_INPUT_DATA  D2In
#define LINE_INPUT_LOAD  D1In

#define CLOCK            IOPut(LINE_CLOCK,  1);IOPut(LINE_CLOCK ,  0)
#define RELE_STROBE      IOPut(LINE_RELE_STROBE, 1);IOPut(LINE_RELE_STROBE , 0)
#define RELE_SET_DATA    IOPut(LINE_RELE_DATA ,  1)
#define RELE_CLEAR_DATA  IOPut(LINE_RELE_DATA ,  0)
#define INPUT_LOAD       IOPut(LINE_INPUT_LOAD,  0);IOPut(LINE_INPUT_LOAD ,  1)
#define INPUT_GET_DATA   (IOGet(D2In))

void SetupLine(){
  IOInit(LINE_CLOCK,out);
  IOInit(LINE_RELE_DATA,out);
  IOInit(LINE_RELE_STROBE,out);
  IOInit(LINE_INPUT_LOAD,out);
  IOInit(LINE_INPUT_DATA,in);
  IOPut(LINE_CLOCK,       0);
  IOPut(LINE_RELE_DATA ,  0);
  IOPut(LINE_RELE_STROBE, 0);
  IOPut(LINE_INPUT_LOAD,  1);
}

void SetRele(int state){
  int i;
  for (i=7;i>=0;i--) {
    if (state & (0x01<<i) ) 
      RELE_SET_DATA;
    else
      RELE_CLEAR_DATA;
    CLOCK;
    RELE_STROBE;
  }
}
unsigned long GetInput(){
  int i;
  unsigned long value;
  INPUT_LOAD;
  for (i=0;i<24;i++) {
    if (INPUT_GET_DATA) value |= 0x01;
    if (i!=23)value <<= 0x01;
    CLOCK;
  }
  return (value);
}

void DS1621_Init(){
  I2CInit(LOW_SPEED);
  DelayMs(5);
  I2CRestart();
  DelayMs(5);
  I2CStart();
  I2CWrite(0x90);
  I2CWrite(0xAC);
  I2CWrite(0x2);
  I2CStart();
  I2CWrite(0x90);
  I2CWrite(0xEE);
  I2CStop();	
}


double DS1621_Read(){
  char tmp[2];
  double temperature;
  I2CStart();
  I2CWrite(0x90);
  I2CWrite(0xAA);
  I2CStart();
  I2CWrite(0x91);
  tmp[0]=I2CRead(0);
  DelayMs(5);
  tmp[1]=I2CRead(1);
  I2CStop();
  temperature =0;
  if (tmp[0] & 0x80) {
    temperature+=(!tmp[0])+1;
    temperature=-temperature;
  } else temperature+=tmp[0];
  if (tmp[1]!=0x0) temperature+=0.5;
  return temperature;
}

void FlyportTask() {
  int i;
  char buffer[255];
  unsigned long CurrentInput;
  

  UARTWrite(1,"Test base SX16\r\n\r\n");
  
  SetupLine();
  DS1621_Init();

  while(1){
    LED2_TOGGLE;
    vTaskDelay(100);

    CurrentInput = GetInput();
    UARTWrite(1,"-----------------\r\n");
    for (i=0;i<24;i++) {
      if (CurrentInput & (0x1L<<i)) 
        sprintf(buffer,"IN %02d [ ]\r\n",(i+1));
      else 
        sprintf(buffer,"IN %02d [X]\r\n",(i+1));
      UARTWrite(1,buffer);
    }

    for(i=0; i<6; i++){
      vTaskDelay(50);
      SetRele(0x01<<i);
      sprintf(buffer, "RELE' %d ON\r\n",(i+1));
      UARTWrite(1,buffer);
      vTaskDelay(50);
    }
    sprintf(buffer, "\r\nTemperatura:\t%.01f C\r\n",DS1621_Read());
    UARTWrite(1,buffer);
  }
}

